;--------------------------------
;Include Modern UI

  !include "MUI.nsh"
;--------------------------------
; The name of the installer
Name "OptiLoading"

; The file to write
OutFile "..\..\dist\win\OptiLoading.exe"

; The default installation directory
InstallDir $PROGRAMFILES\OptiLoading

; Registry key to check for directory (so if you install again, it will 
; overwrite the old one automatically)
InstallDirRegKey HKLM "Software\OptiLoading" "Install_Dir"

!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\win-install.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\win-uninstall.ico"

;--------------------------------
;Interface Configuration

  !define MUI_HEADERIMAGE
  !define MUI_HEADERIMAGE_BITMAP "header.bmp" ; optional
  !define MUI_ABORTWARNING

;--------------------------------
;Language Selection Dialog Settings

  ;Remember the installer language
  !define MUI_LANGDLL_REGISTRY_ROOT "HKLM" 
  !define MUI_LANGDLL_REGISTRY_KEY "Software\OptiLoading" 
  !define MUI_LANGDLL_REGISTRY_VALUENAME "Installer Language"

;--------------------------------

; Pages

  !insertmacro MUI_PAGE_WELCOME
  !insertmacro MUI_PAGE_LICENSE "..\..\LICENSE.txt"
  !insertmacro MUI_PAGE_COMPONENTS
  !insertmacro MUI_PAGE_DIRECTORY
  !insertmacro MUI_PAGE_INSTFILES
  !define MUI_FINISHPAGE_SHOWREADME "$INSTDIR\README.txt"  
  !define MUI_FINISHPAGE_RUN "$INSTDIR\OptiLoading.exe"
  !insertmacro MUI_PAGE_FINISH  

  !insertmacro MUI_UNPAGE_WELCOME
  !insertmacro MUI_UNPAGE_CONFIRM
  !insertmacro MUI_UNPAGE_INSTFILES
  !insertmacro MUI_UNPAGE_FINISH


;--------------------------------
;Languages

  !insertmacro MUI_LANGUAGE "English" ;first language is the default language
  !insertmacro MUI_LANGUAGE "French"
  !insertmacro MUI_LANGUAGE "Dutch"

;--------------------------------

; The stuff to install
Section "OptiLoading (required)"

  SectionIn RO
  
  ; Set output path to the installation directory.
  SetOutPath $INSTDIR
  
  ; Put file there
  File "..\..\dist\win\OptiLoading.exe"
  File "..\..\res\win\lib\glpk_jni.dll"
  File "..\..\res\win\lib\lpsolve55.dll"
  File "..\..\res\win\lib\lpsolve55j.dll"
  File "..\..\README.txt"
  
  ; Write the installation path into the registry
  WriteRegStr HKLM SOFTWARE\OptiLoading "Install_Dir" "$INSTDIR"
  
  ; Write the uninstall keys for Windows
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\OptiLoading" "DisplayName" "OptiLoading (Remove only)"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\OptiLoading" "UninstallString" '"$INSTDIR\uninstall.exe"'
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\OptiLoading" "NoModify" 1
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\OptiLoading" "NoRepair" 1
  WriteUninstaller "uninstall.exe"
  
SectionEnd

; Optional section (can be disabled by the user)
Section "Start Menu Shortcuts"

  CreateDirectory "$SMPROGRAMS\OptiLoading"
  CreateShortCut "$SMPROGRAMS\OptiLoading\Uninstall.lnk" "$INSTDIR\uninstall.exe" "" "$INSTDIR\uninstall.exe" 0
  CreateShortCut "$SMPROGRAMS\OptiLoading\ReadMe.lnk" "$INSTDIR\README.txt" "" "$INSTDIR\README.txt" 0
  CreateShortCut "$SMPROGRAMS\OptiLoading\OptiLoading.lnk" "$INSTDIR\OptiLoading.exe" "" "$INSTDIR\OptiLoading.exe" 0
  
SectionEnd

;--------------------------------

; Uninstaller

Section "Uninstall"
  
  ; Remove registry keys
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\OptiLoading"
  DeleteRegKey HKLM SOFTWARE\OptiLoading

  ; Remove shortcuts, if any
  Delete "$SMPROGRAMS\OptiLoading\*.*"

  ; Remove directories used
  RMDir "$SMPROGRAMS\OptiLoading"
  RMDir /r /REBOOTOK "$INSTDIR"

SectionEnd

;--------------------------------
;Installer Functions

Function .onInit

  !insertmacro MUI_LANGDLL_DISPLAY

FunctionEnd

;--------------------------------
;Uninstaller Functions

Function un.onInit

  !insertmacro MUI_UNGETLANGUAGE
  
FunctionEnd