//: /be/optiloading/compatibility/SegregationComp.java
/*
 * This work is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This work is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * Copyright (c) 2008 Tim Pintens. All rights reserved.
 */

package be.optiloading.compatibility;

import java.util.ArrayList;

/**
 * SegregationComp class used to stow information about the tank-tank compatibility.
 * 
 * @author Tim Pintens, info@optiloading.be
 * @author <a target="_blank"
 *         href="http://www.optiloading.be">www.optiloading.be</a>
 */

@SuppressWarnings("serial")
public class SegregationComp extends ArrayList<ArrayList<Boolean>>{
	
	/**
	 * Add segregation information about tanks.
	 * @param segarray Indicates if tanks are segregated.
	 */
	public void addComp(String segarray){
		char[] sep = segarray.toCharArray();
		ArrayList<Boolean> newItem = new ArrayList<Boolean>();
		for(int i = 0; i < sep.length;i++){
			if(new Character(sep[i]).equals(new Character('0'))){
				newItem.add(new Boolean(false));
			} else{
				newItem.add(new Boolean(true));
			}
		}
		this.add(newItem);
	}
	
	/**
	 * Get a specific segregation value.
	 * @param row Integer with row value.
	 * @param col Integer with column value.
	 * @return Boolean which is false if compatible, otherwise true.
	 */
	public boolean get(int row, int col){
		ArrayList<Boolean> getList = this.get(row);
		return getList.get(col);
	}
}
