//: be/optiloading/help/HelpInfo.java
/*
 * This work is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This work is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * Copyright (c) 2007 Tim Pintens. All rights reserved.
 */

package be.optiloading.help;

import java.net.URL;

/**
 * HelpInfo class holds the title and filename of each help item. These object
 * are added to the HelpTree.
 * 
 * @author Tim Pintens, info@optiloading.be
 * @author <a target="_blank"
 *         href="http://www.optiloading.be">www.optiloading.be</a>
 */

public class HelpInfo {
	public String helpTitle;
	public URL helpURL;

	/**
	 * Constructor
	 * @param title Title of help info file.
	 * @param filename String containing filename.
	 */
	public HelpInfo(String title, String filename) {
		helpTitle = title;
		helpURL = this.getClass().getResource(filename);
	}

	/**
	 * Converts object to string to display the title in the tree
	 */ 
	public String toString() {
		return helpTitle;
	}
}
