//: /be/optiloading/helpers/files/TxtFilter.java
/*
 * This work is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This work is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * Copyright (c) 2008 Tim Pintens. All rights reserved.
 */

package be.optiloading.helpers.files;

import java.io.File;

import javax.swing.filechooser.FileFilter;

import be.optiloading.settings.Settings;

/**
 * Filter to work with JFileChooser to select txt file types.
 * 
 * @author Tim Pintens, info@optiloading.be
 * @author <a target="_blank"
 *         href="http://www.optiloading.be">www.optiloading.be</a>
 */

public class TxtFilter extends FileFilter {
	public boolean accept(File f) {
		return f.getName().toLowerCase().endsWith(".txt") || f.isDirectory();
	}

	public String getDescription() {
		return Settings.getInstance().getResourceBundle().getString("txtFiles");
	}
}
