//: be/optiloading/helpers/table/PercentageRenderer.java
/*
 * This work is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This work is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * Copyright (c) 2007 Tim Pintens. All rights reserved.
 */

package be.optiloading.helpers.table;

import java.text.NumberFormat;

import javax.swing.SwingConstants;
import javax.swing.table.DefaultTableCellRenderer;

/**
 * PercentageRenderer to render percentages in table cells.
 * 
 * @author Tim Pintens, info@optiloading.be
 * @author <a target="_blank"
 *         href="http://www.optiloading.be">www.optiloading.be</a>
 */

@SuppressWarnings("serial")
public class PercentageRenderer extends DefaultTableCellRenderer {
    NumberFormat formatter;
    
    /**
     * Constructor.
     */
    public PercentageRenderer() { 
    	super();
    }

    /**
     * Format value.
     */
    public void setValue(Object value) {
        if (formatter==null) {
            formatter = NumberFormat.getPercentInstance();
            formatter.setMaximumFractionDigits(2);
            formatter.setMinimumFractionDigits(2);
            setHorizontalAlignment(SwingConstants.RIGHT);
        }
        setText((value == null) ? "" : formatter.format(value));
    }
}
