package be.optiloading.test;

import java.awt.AWTEvent;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.event.MouseEvent;
import java.net.URL;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;

public class TestTabbed {
	public static void main(String[] args){
		new TestTabbed();
	}
	
	public TestTabbed(){
		JFrame frame = new JFrame();
		JPanel panel = new JPanel();
		
		URL closeURL = this.getClass().getResource("/images/close.gif");
		ImageIcon closeIcon = new ImageIcon(closeURL);
		ClosableTabbedPane tabbed = new ClosableTabbedPane(closeIcon);
		
		JPanel test1 = new JPanel();
		test1.setSize(new Dimension(500,500));
		JPanel test2 = new JPanel();
		test2.setSize(new Dimension(500,500));
		
		tabbed.addTab("test1", test1);
		tabbed.addTab("test2", test2);
		
		panel.setPreferredSize(new Dimension(500,500));
		
		panel.add(tabbed);
		
		frame.getContentPane().add(BorderLayout.CENTER,panel);
		frame.setSize(500,500);
		frame.setVisible(true);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}
}

@SuppressWarnings("serial")
class ClosableTabbedPane extends JTabbedPane {
	private Icon icon;
    
    public ClosableTabbedPane(Icon closeButtonIcon) {
        enableEvents(AWTEvent.MOUSE_EVENT_MASK);
        icon = closeButtonIcon;
    }
    
    protected void processMouseEvent(MouseEvent evt) {
        int tabNumber = getUI().tabForCoordinate(this, evt.getX(), evt.getY());
 
        if (evt.getID() == MouseEvent.MOUSE_PRESSED && tabNumber > -1
                && ((IconProxy) getIconAt(tabNumber)).contains(
                evt.getX(), evt.getY())) {
 
            int oldSelTab = getSelectedIndex();
            int oldTabCount = getTabCount();
            removeTabAt(tabNumber);
            
            if (tabNumber < oldSelTab && oldSelTab > 0
                    && oldSelTab != (oldTabCount - 1)) {
                
                setSelectedIndex(oldSelTab - 1);
            }
            return;
        }
        super.processMouseEvent(evt);
    }
    
    public void addTab(String title, Component component) {
        addTab(title, new IconProxy(icon), component);
    }
}

class IconProxy implements Icon {
	
    private int x;
    private int y;
    private int xMax;
    private int yMax;
    private int width;
    private int height;
    private Icon icon;
    
    public IconProxy(Icon icon) {
        this.icon = icon;
        width  = icon.getIconWidth();
        height = icon.getIconHeight();
    }
    
    public int getIconWidth() {
        return width;
    }
    
    public int getIconHeight() {
        return height;
    }
    
    public void paintIcon(Component c, Graphics g, int x, int y) {
        this.x = x;
        this.y = y;
        xMax = x + width;
        yMax = y + height;
        icon.paintIcon(c, g, x, y);
    }
    
    public boolean contains(int x, int y) {
        return x >= this.x && x <= xMax && y >= this.y && y <= yMax;
    }
}
