package be.optiloading.test;

import javax.swing.event.UndoableEditEvent;
import javax.swing.event.UndoableEditListener;
import javax.swing.text.BadLocationException;
import javax.swing.text.PlainDocument;
import javax.swing.undo.UndoManager;

public class TestUndo {
    protected UndoManager undo = new UndoManager();
	
	public static void main(String[] args){
		new TestUndo();
	}
	
	public TestUndo(){
		PlainDocument doc = new PlainDocument();
		doc.addUndoableEditListener(new MyUndoableEditListener());
		
		String first = "Test 1";

		try {
			doc.insertString(0, first, null);

		} catch (BadLocationException ble) {
			System.err.println("Couldn't insert initial text.");
		}
		try {
			System.out.println(doc.getText(0, doc.getLength()));
		} catch (BadLocationException e) {
			e.printStackTrace();
		}
		String second = "Test 2";
		try {
			doc.replace(0, doc.getLength(), second, null);
		} catch (BadLocationException ble) {
			System.err.println("Couldn't insert initial text.");
		}
		try {
			System.out.println(doc.getText(0, doc.getLength()));
		} catch (BadLocationException e) {
			e.printStackTrace();
		}
		undo.undo();
		undo.undo();
		try {
			System.out.println(doc.getText(0, doc.getLength()));
		} catch (BadLocationException e) {
			e.printStackTrace();
		}
		
	}
	
	protected class MyUndoableEditListener implements UndoableEditListener {
		public void undoableEditHappened(UndoableEditEvent e) {
			undo.addEdit(e.getEdit());
		}
	}
}
